## CS1060 - hw4
## Twitter

## Import libraries
try:
    import json
except ImportError:
    import simplejson as json

from twitter import Twitter, OAuth, TwitterHTTPError, TwitterStream

## Twitter API OAuth credentials
ACCESS_TOKEN = ''
ACCESS_SECRET = ''
CONSUMER_KEY = ''
CONSUMER_SECRET = ''

oauth = OAuth(ACCESS_TOKEN, ACCESS_SECRET, CONSUMER_KEY, CONSUMER_SECRET)

## Connect and authenticate with Twitter API
twitter = Twitter(auth=oauth)

## generic subsystem for processing twitter API query response data
## heap = can be used to pass data between overloaded functions
## query (heap) := returns the result of a twitter APi query
## condition := runs user specified condition function
## post_condition := runs user specified post_condition function
## process (data, heap) := runs user specified process function
## initialize (heap) := runs user specified initialize function
## delimit (resp, heap) := runs user specified data delimiter function
## finalize (heap) := runs user specified post process function
def twitter_query(query, process, initialize=None, condition=None, post_condition=None, delimit=None, finalize=None):
    # shared data heap
    heap = {}

    if initialize is not None:
        initialize(heap)

    if condition is not None:
        while condition(heap):
            resp = query(heap)
            if delimit is not None:
                for data in delimit(resp, heap):
                    process(data, heap)
            else:
                process(resp, heap)
            if post_condition is not None:
                post_condition(heap)
    else:
        resp = query(heap)
        if delimit is not None:
            for data in delimit(resp, heap):
                process(data, heap)
        else:
            process(resp, heap)

    if finalize is not None:
        finalize(heap)

