from hw4 import *

## initialize(heap)
## heap := shared data heap
##
## This function is executed before anything else.
## This function creates the following data structures on the heap:
## word_count = dictionary of word keys with values representing word occurance count.
def initialize(heap):
    heap["word_count"] = {}

## query(heap)
## heap := shared data heap
## := JSON response
##
## This function builds the query request that is sent to twitter.
## It returns the JSON data that twitter reponds.
## This function asks twitter for count number of tweets that match search
def query(heap):
    return twitter.search.tweets(q=search, count=count)

## delimit(data, heap)
## data := JSON response
## heap := shared data heap
## := List of space delimited words
##
## This function pre processes data from the twitter query.
## It creates a list of elements that process() will run on.
## In this function, it adds each word separated by " " in the tweet to the list to_process
## process() is then called on each word in the to_process list
def delimit(data, heap):
    to_process = []
    tweet_count = 0
    for tweet in data["statuses"]:
        #if 'text' in tweet:
        #    tweet_count = tweet_count + 1
        #    print 'tweet',tweet_count,':',
        #    print tweet['text']
        for word in tweet["text"].split(" "):
            to_process.append(word)
    return to_process

## process(word, heap)
## word := a word
## heap := shared data heap
##
## This function processes the words in the to_process List one a ta time.
## If the word key exists in the word_count dictionary it increments the value
## of the word key's value by 1.
## If the word key does not exist in the word_count dictionary it adds it with a value of 1.
def process(word, heap):
    if word in heap["word_count"]:
        heap["word_count"][word] += 1
    else:
        heap["word_count"][word] = 1

## finalize(heap)
## heap := shared data heap
##
## This function is executed after the main program while loop terminates.
## This function prints out the dictionary key's and their corresponding values
def finalize(heap):
    print("Occurances of word in tweets")
    for word in words:
        if word in heap["word_count"]:
            print("{}: {}".format(word, heap["word_count"][word]))

## EDIT THIS AREA ONLY

## hashtag to search
search = "#trump"

## count of tweets to receive
count = "10"

## words to count the occurance of
words = ["the", "and", "in", "Hilary", "win", "Donald", "only"]

## END OF EDIT AREA

twitter_query(query, process, initialize=initialize, delimit=delimit, finalize=finalize)
